/* eshot.c */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>		/* sin,cos g߂ */
#include <sys/iocs.h>
#include "XSP2lib.H"

#define PCG_MAX	32		/* p^[f[^̌ */

static char pcg_alt[PCG_MAX + 1];	/* obfzuǗe[u */
static char pcg_dat[PCG_MAX * 128];	/* obff[^t@Cǂݍ݃obt@ */

static unsigned short pal_dat[16][15];	/* pbgf[^ */


#define ESHOT_MAX	200	/* Geő吔 */
#define ESHOT_SPEED	0.75	/* Gȇx */


/* Ge\ */
typedef struct _eshot {
	signed short x;		/* GêwW */
	signed short y;		/* @V@xW */
	unsigned char type;	/* @V@ށi=0 Ȃ疢gpj */
	signed int lx, ly;	/* 32bit X,Y W ( l = longword ) */
	signed int vx, vy;	/* 32bit X,Y x ( v = velocity ) */
	struct _eshot *next;	/* ̍\̂ւ̃|C^ */
} ESHOT;

ESHOT *eshot_top;		/* gp̃[ÑXg */
int eshot_count;		/* Ge̐ */



typedef struct {
	signed int x, y;
} VECTOR;

VECTOR xytable[256];		/* sin,cos e[u */



/* Q[JnɌĂ΂ */
void EshotInit (void)
{
	eshot_count = 0;	/* Ge͂O */
}



/* GeoɌĂ΂ */
/*  : , wW, xW, px */
void EshotAlloc (unsigned char type, signed short x, signed short y, unsigned char angle)
{
	ESHOT *p;

	if (eshot_count >= ESHOT_MAX)	/* Ge ESHOT_MAX zĂ邩H */
		return;		/* ȏ͏oȂ */
	eshot_count++;

	p = malloc (sizeof (ESHOT));	/* m[hPm */
	if (p == NULL)		/* mۂłH */
		return;		/* mۂłȂisj */

    /* Xg\ŊǗ */
	if (eshot_top == NULL) {
	    /* PeoĂȂꍇ */
		p->next = NULL;	/* ͂Ȃ */
	} else {
		p->next = eshot_top;	/* u܂ł̐擪vumۂm[hv̎ɂ */
	}
	eshot_top = p;		/* mۂm[h擪ɂ */

	p->lx = (x - 8) * 65536;	/* (8,8) XvCgW̒SȂ̂ŕ␳ */
	p->ly = (y - 8) * 65536;
	p->vx = xytable[angle].x;
	p->vy = xytable[angle].y;
	p->type = type;
}



/* ƂɌĂ΂ */
void EshotMove (void)
{
	ESHOT *p, *q;

	p = eshot_top;		/* ݒڂĂ郏[N */
	q = NULL;		/* PÕ[Ni[N폜ɕKvj */

	while (p != NULL) {
		p->lx += p->vx;	/* vx ړ */
		p->ly += p->vy;	/* vy ړ */

		p->x = p->lx / 65536;	/* lx ̐o x  */
		p->y = p->ly / 65536;	/* ly ̐o y  */

	    /* GeʊOɏoH */
		if ((p->x < 0) || (p->x > 256 + 16) || (p->y < 0) || (p->y > 256 + 16)) {
		    /* ʊOɏôŏ */
			eshot_count--;

			if (q == NULL) {	/* Xg̈ԍŏ폜 */
				eshot_top = p->next;
				free (p);	/* J */
				q = NULL;
				p = eshot_top;
			} else {
				q->next = p->next;
				free (p);	/* J */
				p = q->next;
			}
		} else {
			xsp_set (p->x, p->y, p->type, 0x033f);

			q = p;
			p = p->next;
		}
	}
}



int main (int argc, char *argv[])
{
	FILE *fp;
	int i, j;
	int game_over = 0;
	unsigned char angle = 0;	/* Ɍe̊px */
	unsigned char type = 1;	/* Ɍe̎ */
	int sprites;		/* XvCg̖ */

	if (argc != 1) {
		printf (
			       "GeeXĝT ESHOT.X\n"
			       "		programmed by Mitsuky <FreeSoftware>\n"
			       "ẽ[NXg\ŊǗ悤ɂ\n"
			       "eƉʂ̒o悤ɂ\n"
			);
		exit (-1);
	}
	printf ("f[^e[u쐬܂B\n");
	for (i = 0; i < 256; i++) {
		xytable[i].x = (signed int) (cos (2.0 * M_PI * (long) i / 256.0) * 65536.0 * ESHOT_SPEED);
		xytable[i].y = (signed int) (sin (2.0 * M_PI * (long) i / 256.0) * 65536.0 * ESHOT_SPEED);
	}


	_iocs_crtmod (10);	/* 256x256hbg OtBbN 256F Q */
	_iocs_g_clr_on ();	/* OtBbNʂ̏ */
	_iocs_sp_init ();	/* XvCg̏ */
	_iocs_sp_on ();

    /* pcg_dat Ƀp^[f[^ǂݍ */
	fp = fopen ("ESHOT.SP", "rb");
	fread (pcg_dat, sizeof (char), PCG_MAX * 128, fp);
	fclose (fp);

    /* pal_buf ɈUpbgf[^ǂݍ */
	fp = fopen ("ESHOT.PAL", "rb");
	fread (pal_dat, sizeof (unsigned short), 16 * 15, fp);
	fclose (fp);
    /* pbgf[^` */
    /* iPpbgubN16Fj ~ i15ubNԂj ` */
	{
		unsigned short *p = (unsigned short *) pal_dat;
		for (i = 1; i < 15; i++)
			for (j = 0; j < 16; j++)
				_iocs_spalet (0x80000000 | j, i, *p++);
	}

	xsp_on ();
	xsp_mode (3);
    /* p^[f[^` */
	xsp_pcgdat_set (pcg_dat, pcg_alt, sizeof (pcg_alt));

    /* OtBbNʂɐ */
	{
		struct _lineptr lp;
		lp.x1 = 0;
		lp.y1 = 128;
		lp.x2 = 255;
		lp.y2 = 128;
		lp.color = 15;
		lp.linestyle = 0xaaaa;
		_iocs_line (&lp);
		lp.x1 = 128;
		lp.y1 = 0;
		lp.x2 = 128;
		lp.y2 = 255;
		_iocs_line (&lp);
	}

	printf ("WCXeBbN\n"
		" [B] {^ƒe܂\n"
		" [A] {^ƏI܂\n");


	EshotInit ();

	do {
		xsp_vsync (0);	/* ҂ */
		j = _iocs_joyget (0);	/* WCXeBbNO */

	    /* [A] {^ꂽH */
		if ((j & 0b00100000) == 0)
			game_over = !0;		/* Q[I[o[ */

	    /* [B] {^ꂽH */
		if ((j & 0b1000000) == 0) {
			EshotAlloc (type, 144, 144, angle);	/*  type ̓GeW(144,144)Apx angle Ŕ */
			angle += 8;	/* pxi߂ */
			type++;	/* ނi߂iӖj */
			if (type > 5)
				type = 1;
		}
		EshotMove ();
		sprites = xsp_out ();	/* \ */

		printf ("e = %3d  \n\x0b", sprites);
	    /* 0x0b ̓J[\PsɈړ */
	    /* Human68K [U[Y}jA̕t^ ASCII R[h̗Q */
	} while (!game_over);

	xsp_off ();

	_iocs_crtmod (16);
	return (0);
}
